///////////////////////////////////////////////////////////////////////////
//
// Hi.  Why are you reading this?  You shouldn't be...
//
///////////////////////////////////////////////////////////////////////////

#include "PackageBase.h"

/////////////////////////////////////////////////////////////////////////////////////////
// CUserDefComponentBase methods
/////////////////////////////////////////////////////////////////////////////////////////

CUserDefComponentBase::~CUserDefComponentBase()
{
	m_pSMOKObj = 0;
	m_pReadMemProc = 0;
	m_pWriteMemProc = 0;
}

/////////////////////////////////////////////////////////////////////
// The smok-side component should call this routine during the
// creation sequence.  It allows limited access back to the
// smok object.  (At the moment, it allows reading/writing of
// the memory attached to a memory port.)
/////////////////////////////////////////////////////////////////////

void CUserDefComponentBase::RegisterCallbacks( void* pSMOKObj, READMEMPORT_PROC pReadMemProc, WRITEMEMPORT_PROC pWriteMemProc )
{
	m_pSMOKObj = pSMOKObj;
	m_pReadMemProc = pReadMemProc;
	m_pWriteMemProc = pWriteMemProc;
}

int CUserDefComponentBase::ReadMemory ( int inputPortNum, int address, int numBytes )
{
	if ( m_pReadMemProc && m_pSMOKObj ) {
		return m_pReadMemProc( m_pSMOKObj, inputPortNum, address, numBytes );
	}
	return 0;
}

void CUserDefComponentBase::WriteMemory( int inputPortNum, int address, int data, int numBytes )
{
	if ( m_pWriteMemProc && m_pSMOKObj ) {
		m_pWriteMemProc( m_pSMOKObj, inputPortNum, address, data, numBytes );
	}
}
