#!/bin/bash

if [[ -e /cygdrive/c/ && $CYGWIN.test != "tty.test" ]]; then
	echo "You must set environment variable CYGWIN to tty before starting a cygwin shell."
	echo "Right-click on My Computer, then Properties, then Advanced, then Environment Variables."
	echo "Then kill this cygwin window and start a new one."
	exit 1;
fi

if [ $# -ne 1 ]; then
	echo "Use: ./cebrun.sh <appname>"
	exit 1;
fi

fname=`basename $1`
if [ $fname == "image" ]; then
    echo Turning off character echoing...
    stty -echo -icanon min 1
    java dbg.UI --bootable image
    stty echo icanon
    exit 0
fi

if [ ! -e $fname ]; then
    echo $fname does not exist
    exit 1;
fi

stty -echo -icanon min 1
java dbg.UI $fname
stty echo icanon
